.include "m128def.inc"

.org 0
	rjmp	reset

reset:
	; setup stack pointer
	ldi		r16, low(RAMEND)
	out		SPL, r16
	ldi		r16, high(RAMEND)
	out		SPH, r16

	; disable analog comparater
	ldi		r20, (1<<ACD)
	out		ACSR, r20

	ldi		r22, 0x55
	ldi		r23, 0xAA

	ldi		r16, (1<<AS0)
	out		ASSR, r16 ; use 32kHz crystal for Timer0
	ldi		r16, (0<<CS02)|(1<<CS01)|(1<<CS00)	; prescaler /32
	out		TCCR0, r16

loop:
	in		r16, TIFR
	sbrs	r16, TOV0
	rjmp	loop	; loop until Timer0 overflows
	ldi		r16, (1<<TOV0)
	out		TIFR, r16	; clear overflow flag

	out		DDRA, r22
	out		PORTA, r23
	out		DDRB, r22
	out		PORTB, r23
	out		DDRC, r22
	out		PORTC, r23
	out		DDRD, r22
	out		PORTD, r23
	out		DDRE, r22
	out		PORTE, r23
	sts		DDRF, r22
	sts		PORTF, r23
	sts		DDRG, r22
	sts		PORTG, r23

	com		r22
	com		r23

	rjmp	loop

.end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

:020000020000FC
:1000000000C00FEF0DBF00E10EBF40E848B965E545
:100010007AEA08E000BF03E003BF06B700FFFDCFA8
:1000200001E006BF6ABB7BBB67BB78BB64BB75BB2B
:1000300061BB72BB62B973B9609361007093620077
:0E004000609364007093650060957095E6CF44
:00000001FF

