.include "m128def.inc"

.org 0
	rjmp	reset

reset:
	; setup stack pointer
	ldi		r16, low(RAMEND)
	out		SPL, r16
	ldi		r16, high(RAMEND)
	out		SPH, r16

	; disable analog comparater
	ldi		r20, (1<<ACD)
	out		ACSR, r20

	ldi		r22, 0x55
	ldi		r23, 0xAA

loop:
	out		DDRA, r22
	out		PORTA, r23
	out		DDRB, r22
	out		PORTB, r23
	out		DDRC, r22
	out		PORTC, r23
	out		DDRD, r22
	out		PORTD, r23
	out		DDRE, r22
	out		PORTE, r23
	sts		DDRF, r22
	sts		PORTF, r23
	sts		DDRG, r22
	sts		PORTG, r23

	com		r22
	com		r23

	rcall	delay
	rjmp	loop

delay:
	ldi		r19, 1
delay_1:
	ldi		r18, 0
delay_2:
	ldi		r17, 0
delay_3:
	dec		r17
	brne	delay_3
	dec		r18
	brne	delay_2
	dec		r19
	brne	delay_1
	ret

